//
// OrganizationsAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class OrganizationsAPI {
    /**
     Create new organization

     - parameter body: (body)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func createOrganization(body: OrganizationCreate, completion: @escaping ((_ data: OrganizationGet?,_ error: Error?) -> Void)) {
        createOrganizationWithRequestBuilder(body: body).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Create new organization
     - POST /api/v1/organizations
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "is_internal" : true,
  "logo_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
  "logo_url" : "http://example.com/aeiou",
  "name" : "name",
  "description" : "description",
  "id" : 0
}}]
     - parameter body: (body)  

     - returns: RequestBuilder<OrganizationGet> 
     */
    open class func createOrganizationWithRequestBuilder(body: OrganizationCreate) -> RequestBuilder<OrganizationGet> {
        let path = "/api/v1/organizations"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<OrganizationGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Delete organization with provided ID

     - parameter organizationId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func deleteOrganization(organizationId: Int, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        deleteOrganizationWithRequestBuilder(organizationId: organizationId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Delete organization with provided ID
     - DELETE /api/v1/organizations/{organization_id}

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter organizationId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func deleteOrganizationWithRequestBuilder(organizationId: Int) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/organizations/{organization_id}"
        let organizationIdPreEscape = "\(organizationId)"
        let organizationIdPostEscape = organizationIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{organization_id}", with: organizationIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get organization with provided ID

     - parameter organizationId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getOrganization(organizationId: Int, completion: @escaping ((_ data: OrganizationGet?,_ error: Error?) -> Void)) {
        getOrganizationWithRequestBuilder(organizationId: organizationId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get organization with provided ID
     - GET /api/v1/organizations/{organization_id}
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "is_internal" : true,
  "logo_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
  "logo_url" : "http://example.com/aeiou",
  "name" : "name",
  "description" : "description",
  "id" : 0
}}]
     - parameter organizationId: (path)  

     - returns: RequestBuilder<OrganizationGet> 
     */
    open class func getOrganizationWithRequestBuilder(organizationId: Int) -> RequestBuilder<OrganizationGet> {
        var path = "/api/v1/organizations/{organization_id}"
        let organizationIdPreEscape = "\(organizationId)"
        let organizationIdPostEscape = organizationIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{organization_id}", with: organizationIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<OrganizationGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get list of organization groups

     - parameter organizationId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getOrganizationGroups(organizationId: Int, completion: @escaping ((_ data: OrganizationGroupList?,_ error: Error?) -> Void)) {
        getOrganizationGroupsWithRequestBuilder(organizationId: organizationId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get list of organization groups
     - GET /api/v1/organizations/{organization_id}/groups
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "groups" : [ {
    "is_internal" : true,
    "place_count" : 5,
    "user_count" : 1,
    "organization_id" : 6,
    "name" : "name",
    "description" : "description",
    "id" : 0,
    "organization_name" : "organization_name"
  }, {
    "is_internal" : true,
    "place_count" : 5,
    "user_count" : 1,
    "organization_id" : 6,
    "name" : "name",
    "description" : "description",
    "id" : 0,
    "organization_name" : "organization_name"
  } ]
}}]
     - parameter organizationId: (path)  

     - returns: RequestBuilder<OrganizationGroupList> 
     */
    open class func getOrganizationGroupsWithRequestBuilder(organizationId: Int) -> RequestBuilder<OrganizationGroupList> {
        var path = "/api/v1/organizations/{organization_id}/groups"
        let organizationIdPreEscape = "\(organizationId)"
        let organizationIdPostEscape = organizationIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{organization_id}", with: organizationIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<OrganizationGroupList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get list of organization members

     - parameter organizationId: (path)  
     - parameter withoutGroups: (query)  (optional, default to false)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getOrganizationMembers(organizationId: Int, withoutGroups: Bool? = nil, completion: @escaping ((_ data: OrganizationMemberList?,_ error: Error?) -> Void)) {
        getOrganizationMembersWithRequestBuilder(organizationId: organizationId, withoutGroups: withoutGroups).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get list of organization members
     - GET /api/v1/organizations/{organization_id}/members
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "members" : [ {
    "avatar_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "is_active" : true,
    "is_superuser" : true,
    "avatar_url" : "http://example.com/aeiou",
    "role_id" : 5,
    "organization_id" : 6,
    "last_name" : "last_name",
    "groups" : [ {
      "name" : "name",
      "id" : 1
    }, {
      "name" : "name",
      "id" : 1
    } ],
    "id" : 0,
    "organization_name" : "organization_name",
    "first_name" : "first_name",
    "email" : ""
  }, {
    "avatar_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "is_active" : true,
    "is_superuser" : true,
    "avatar_url" : "http://example.com/aeiou",
    "role_id" : 5,
    "organization_id" : 6,
    "last_name" : "last_name",
    "groups" : [ {
      "name" : "name",
      "id" : 1
    }, {
      "name" : "name",
      "id" : 1
    } ],
    "id" : 0,
    "organization_name" : "organization_name",
    "first_name" : "first_name",
    "email" : ""
  } ]
}}]
     - parameter organizationId: (path)  
     - parameter withoutGroups: (query)  (optional, default to false)

     - returns: RequestBuilder<OrganizationMemberList> 
     */
    open class func getOrganizationMembersWithRequestBuilder(organizationId: Int, withoutGroups: Bool? = nil) -> RequestBuilder<OrganizationMemberList> {
        var path = "/api/v1/organizations/{organization_id}/members"
        let organizationIdPreEscape = "\(organizationId)"
        let organizationIdPostEscape = organizationIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{organization_id}", with: organizationIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "without_groups": withoutGroups
        ])


        let requestBuilder: RequestBuilder<OrganizationMemberList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get list of organizations

     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getOrganizations(completion: @escaping ((_ data: OrganizationList?,_ error: Error?) -> Void)) {
        getOrganizationsWithRequestBuilder().execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get list of organizations
     - GET /api/v1/organizations
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "organizations" : [ {
    "is_internal" : true,
    "logo_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "logo_url" : "http://example.com/aeiou",
    "name" : "name",
    "description" : "description",
    "id" : 0
  }, {
    "is_internal" : true,
    "logo_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "logo_url" : "http://example.com/aeiou",
    "name" : "name",
    "description" : "description",
    "id" : 0
  } ]
}}]

     - returns: RequestBuilder<OrganizationList> 
     */
    open class func getOrganizationsWithRequestBuilder() -> RequestBuilder<OrganizationList> {
        let path = "/api/v1/organizations"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<OrganizationList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Search organizations by provided query string

     - parameter body: (body)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func searchOrganizations(body: OrganizationSearchBody, completion: @escaping ((_ data: OrganizationList?,_ error: Error?) -> Void)) {
        searchOrganizationsWithRequestBuilder(body: body).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Search organizations by provided query string
     - POST /api/v1/organizations/search

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "organizations" : [ {
    "is_internal" : true,
    "logo_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "logo_url" : "http://example.com/aeiou",
    "name" : "name",
    "description" : "description",
    "id" : 0
  }, {
    "is_internal" : true,
    "logo_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "logo_url" : "http://example.com/aeiou",
    "name" : "name",
    "description" : "description",
    "id" : 0
  } ]
}}]
     - parameter body: (body)  

     - returns: RequestBuilder<OrganizationList> 
     */
    open class func searchOrganizationsWithRequestBuilder(body: OrganizationSearchBody) -> RequestBuilder<OrganizationList> {
        let path = "/api/v1/organizations/search"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<OrganizationList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Update organization with provided ID

     - parameter body: (body)  
     - parameter organizationId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func updateOrganization(body: OrganizationUpdate, organizationId: Int, completion: @escaping ((_ data: OrganizationGet?,_ error: Error?) -> Void)) {
        updateOrganizationWithRequestBuilder(body: body, organizationId: organizationId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Update organization with provided ID
     - PUT /api/v1/organizations/{organization_id}
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "is_internal" : true,
  "logo_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
  "logo_url" : "http://example.com/aeiou",
  "name" : "name",
  "description" : "description",
  "id" : 0
}}]
     - parameter body: (body)  
     - parameter organizationId: (path)  

     - returns: RequestBuilder<OrganizationGet> 
     */
    open class func updateOrganizationWithRequestBuilder(body: OrganizationUpdate, organizationId: Int) -> RequestBuilder<OrganizationGet> {
        var path = "/api/v1/organizations/{organization_id}"
        let organizationIdPreEscape = "\(organizationId)"
        let organizationIdPostEscape = organizationIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{organization_id}", with: organizationIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<OrganizationGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
}
